*  FILE: ADVENT01/ASM
*
* VERB PROCESSING ROUTINES
*

*******************************
*
* "LOOK" VERB HANDLER
*
*******************************

VLOOK EQU *
 JSR INDARK
 LBEQ REPLY
 LDA NOUNNO
 LBNE LOOKOB
 JSR CLS
VLOOK2 EQU *
 JSR DRAWSC
 LDB ROOM
A@ LDX #DESCTB DESCRIPTIONS
B@ DECB FIND DESC FOR THIS ROOM
 BEQ D@
C@ TST ,X+
 BNE C@
 BRA B@
D@ LDA ,X 1ST CHAR OF DESC
 CMPA #PNT IS IT POINTER?
 BNE E@ NO:DISPLAY IT
 LDB 1,X GET NEW ROOM #
 BRA A@ DISPLAY NEW ROOM
E@ JSR DISPLY DISPLAY ROOM DESC
 LDA ROOM DISPLAY ALL DIRECTIONS
 DECA
 LDB #RMSIZE
 MUL
 ADDD #ROOMTB
 TFR D,Y
 TFR D,X SEE IF ANY EXITS
 LDB #6
P@ TST ,X+
 BNE Q@
 DECB
 BNE P@
 BRA R@
Q@ LDX #MSG1 DIRECTION MSG
 JSR DISPLY
 LDX #DIRECT
 LDB #6
F@ LDA ,Y+
 BEQ G@ DIRECTION NOT AVAIL
 BMI G@ DIRECTION UNSEEN
 JSR DISPLY
G@ TST ,X+
 BNE G@
 DECB
 BNE F@
 JSR PERIOD
R@ JSR PNTRM1
 TFR X,Y
 LDA ,X
 BEQ O@
 LDX #MSG2 OBJECTS SEEN MSG
 JSR DISPLY
M@ LDX #OBJTAB OBJECT DESC TBL
 LDA ,Y+ ROOMTB OBJ PNTR
 BEQ N@ END OF OBJECTS
 BMI M@ UNSEEN OBJECT
 JSR OBDESC
 LDX #COMMA
 JSR DISPLY
 BRA M@
N@ JSR PERIOD
O@ JMP REPLY

*******************************
*
* GENERAL LOOK AT OBJECT RTN
*
*******************************

LOOKOB EQU *
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #7 IS IT A DIRECTION?
 LBLO DMSG12 YES
 CLRB
 JSR HAVOBJ
 BNE B@
 LDA NOUNNO
 JSR CKOBJ
 BEQ NOSEE
 INCB
B@ INCB
 LDX #OBJMSG
C@ TST ,X
 LBEQ DMSG12
 CMPA ,X
 BEQ D@
 LEAX 3,X
 BRA C@
D@ LDA B,X
 CMPA #7
 BEQ NOSEE
 CMPA #8
 BEQ ALRHAV
 CMPA #10
 BEQ NOHAVE
 JMP DMSGXX

*******************************
*
*  GENERAL DON'T SEE ROUTINE
*
*******************************

NOSEE EQU *
 LDX #MSG7
NOSEE1 JSR DISPLY
 LDA NOUNNO
 LDX #THEMTB
 CLRB
A@ TST ,X
 BEQ B@
 CMPA ,X++
 BNE A@
 LDB -1,X
B@ LDX #LITTAB
C@ TSTB
 BEQ E@
D@ TST ,X+
 BNE D@
 DECB
 BRA C@
E@ JSR DISPLY
 JMP REPLY

*******************************
*
*  GENERAL DON'T HAVE ROUTINE
*
*******************************

NOHAVE EQU *
 LDX #MSG10
 BRA NOSEE1

*******************************
*
* GENERAL ALREADY HAVE ROUTINE
*
*******************************

ALRHAV EQU *
 LDX #MSG8
 BRA NOSEE1

*******************************
*
* DISPLAY OBJECT DESCRIPTION
*
* INPUT:  A = OBJ #
* OUTPUT: NONE
*
*******************************

OBDESC EQU *
 PSHS D,X
A@ LDX #OBJTAB
B@ CMPA ,X+
 BEQ D@
C@ TST ,X+
 BNE C@
 BRA B@
D@ LDA ,X
 CMPA #PNT
 BNE E@
 LDA 1,X
 BRA A@
E@ JSR DISPLY
 PULS D,X,PC

*******************************
*
* I FOUND AN OBJECT ROUTINE
*
* INPUT:  A = OBJ #
*
*******************************

IFOUND EQU *
 LDX #MSG11
 JSR DISPLY
 JSR OBDESC
 LDA #'!'
 JSR CHROUT
 JMP REPLY

*******************************
*
* GO VERB PROCESSOR
*
*******************************

VNORTH LDA #1
 FCB $8C
VSOUTH LDA #2
 FCB $8C
VEAST LDA #3
 FCB $8C
VWEST LDA #4
 FCB $8C
VUP LDA #5
 FCB $8C
VDOWN LDA #6
 STA NOUNNO
VGO LDA NOUNNO VERIFY DIRECTION
 BEQ C@
 BMI C@
D@ CMPA #6
 BHI C@
 LDB ROOM CALC ADDR IN ROOMTB
 DECB
 LDA #RMSIZE
 MUL
 ADDD #ROOMTB
 TFR D,X
 LDA NOUNNO GET NEXT ROOM #
 DECA
 LDA A,X
 BEQ B@ NO ROOM THAT DIRECTION
 BMI B@ UNSEEN ROOM
EXITRM EQU *
 TFR A,B
 LDX #EXITTB SPECIAL EXIT RTNS
E@ LDA ,X+
 BEQ G@
 CMPA ROOM
 BEQ F@
 LEAX 2,X
 BRA E@
F@ JSR [,X]
G@ INC NEWRM
 STB ROOM SET NEW ROOM
 CLR NOUNNO
A@ JMP VLOOK
B@ LDX #MSG3 NO WAY TO GO
 JSR DISPLY
 JMP REPLY
C@ JMP BADINP

*******************************
*
* INVENTORY VERB PROCESSOR
*
*******************************

VINVE EQU *
***LDX #GSCRN
***STX SCRTOP
 LDX #MSG5 I AM CARRYING MSG
 JSR DISPLY
 LDX #OBJECT OBJ CARRYING TBL
 LDD #MAXOBJ SEE IF CARRYING
A@ TST ,X+ .. ANYTHING
 BEQ B@
 INCA
B@ DECB
 BNE A@
 TSTA CARRYING ANYTHING?
 BEQ I@ NO
 LDY #OBJECT
 LDB #MAXOBJ
C@ LDA ,Y+ DISPLAY OBJECTS
 BEQ G@
 LDX #OBJTAB
D@ CMPA ,X+
 BEQ F@
E@ TST ,X+
 BNE E@
 BRA D@
F@ LDA ,X
 CMPA #PNT IS IT POINTER?
 BNE J@
 LDA 1,X
 LDX #OBJTAB
 BRA D@
J@ LDA #13
 JSR CHROUT
 JSR DISPLY
 LDX #COMMA
 JSR DISPLY
G@ DECB
 BNE C@
 JSR PERIOD
H@ JMP REPLY
I@ LDX #MSG6 CARRYING NOTHING
 JSR DISPLY
 BRA H@

*******************************
*
* PUT VERB PROCESSOR
*
*******************************

VPUT EQU *
 JSR EQUOBJ
 LDA NOUNNO GOOD OBJ NUMBER?
 LBEQ BADINP NO
 CMPA #128 IS IT "PUT ALL"?
 BEQ E@ YES
 JSR HAVOBJ
 LBEQ NOHAVE
 JSR PUTOBJ
 JSR CKDRAW
 CLRB
 JSR REPOBJ
D@ JMP REPLY
E@ LDX #OBJECT HANDLE "PUT ALL"
 LDB #MAXOBJ
F@ LDA ,X+
 BEQ G@
 JSR CHKPA CHK ADV RESTRICT
 BEQ G@
 CLR -1,X
 DEC OBJCNT
 JSR PUTOBJ
 JSR CKDRAW
G@ DECB
 BNE F@
 BRA D@

 IFEQ R.PNRM
*******************************
*== PUTNRM ==
* PUT AN OBJECT IN A ROOM WITH
* NO POINT OR MOVED LOCATION
* CHECKING
*
* INPUT:  A = OBJECT #
*
*******************************

PUTNRM EQU *
 PSHS D,X,Y
 TSTA
 BEQ C@
 JSR PNTRM1
A@ TST ,X+
 BNE A@
 LEAX -1,X
 LDY #RMOBT2-1
B@ LDB ,-Y
 STB 1,Y
 PSHS Y
 CMPX ,S++
 BNE B@
 STA ,X
C@ PULS D,X,Y,PC
 ENDC

*******************************
*== PUTOBJ ==
* PUT OBJECT IN CURRENT ROOM
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: NONE
*
*******************************

VEC17 EQU *
 PSHS D,X,Y
 TSTA
 BEQ H@
 DI
 LDB ROOM
 PSHS B
 LDX #PUTTAB
A@ TST ,X
 BEQ C@
 CMPB ,X
 BEQ B@
 LEAX 2,X
 BRA A@
B@ LDB 1,X
 STB ROOM
C@ JSR PNTRM1
D@ TST ,X+
 BNE D@
 LEAX -1,X
 LDY #RMOBT2-1
E@ LDB ,-Y
 STB 1,Y
 PSHS Y
 CMPX ,S++
 BNE E@
 STA ,X
 LDB ROOM
 CMPB #TRESRM TREASURE ROOM
 BNE G@
 LDX #PNTTAB
F@ TST ,X
 BEQ G@
 CMPA ,X++
 BNE F@
 LDA -1,X
 ADDA POINTS
 STA POINTS
 CLR -1,X
G@ PULS B
 STB ROOM
 EI
H@ PULS D,X,Y,PC

 IFEQ R.RVIS
*******************************
*== RMVIS ==
* MAKE ROOM VISIBLE
*
* INPUT:  A = INVISIBLE ROOM #
*
*******************************

VEC18 EQU *
 PSHS B,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB
 TFR D,X
 PULS A
 LDB #6
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B,X,PC
B@ ANDA #$7F
 STA -1,X
 PULS B,X,PC
 ENDC

*******************************
*== CKDRAW ==
* CHECK IF SCREEN NEEDS TO BE
* RE-DRAWN
*
*******************************

VEC19 EQU *
 PSHS D,X
 TFR A,B
 JSR INDARK
 BEQ C@
 TFR B,A
 LDX #MOVOBJ
A@ TST ,X
 BEQ C@
 CMPA ,X+
 BNE D@
F@ TST ,X+
 BNE F@
B@ LDB ,X+
 BEQ A@
 CMPB ROOM
 BNE B@
 LDD ROWCOL
 PSHS D
 JSR DRAWSC
 PULS D
 CMPD #$0B00
 BLO C@
 STD ROWCOL
C@ PULS D,X,PC
D@ TST ,X+
 BNE D@
E@ TST ,X+
 BNE E@
 BRA A@

*******************************
*== DRAWSC ==
* RE-DRAW GRAPHIC SCREEN
*
*******************************

VEC20 EQU *
 PSHS D,X,Y,U
 LDD #GSCRN
 STD SCRTOP
 JSR PNTRM2
 LDA ,X
 DECA
 LSLA
 LDX #SCRTAB
 LDU A,X
 JSR SHOSC2
 JSR SHOOBJ
 LDD #$0B00
 STD ROWCOL
 LDD #GSCRN+288*10
 STD SCRTOP
A@ PULS D,X,Y,U,PC

*******************************
* == XFROBJ ==
* TRANSFER MOVABLE OBJECTS
* FROM ONE ROOM TO ANOTHER.
*
* INPUT:  A= FROM ROOM
*         B= TO ROOM
*
*******************************

 IFEQ R.XFOB
XFROBJ EQU *
 PSHS D,X,U
 DI
 TFR D,U
 LDA ROOM
 PSHS A
 TFR B,A
 JSR CLROBJ
A@ TFR U,D
 STA ROOM
 JSR PNTRM1
B@ LDA ,X+
 BEQ C@
 CMPA #MXMVOB
 BHI B@
 JSR GETOBJ
 BEQ B@
 STB ROOM
 JSR PUTNRM
 BRA A@
C@ PULS B
 STB ROOM
 EI
 PULS D,X,U,PC
 ENDC

*******************************
* == CLRRM ==
* REMOVE ALL OBJECTS FROM A
* ROOM
*
* INPUT:  A= ROOM TO CLEAR
*
*******************************

CLRRM EQU *
 PSHS D,X
 DI
 LDB ROOM
 PSHS B
 STA ROOM
 JSR PNTRM1
A@ LDA ,X
 BEQ B@
 JSR GETOBJ
 BRA A@
B@ PULS B
 STB ROOM
 EI
 PULS D,X,PC

*******************************
* == CLROBJ ==
* REMOVE ALL MOVABLE OBJECTS
* FROM A ROOM
*
* INPUT:  A= ROOM TO CLEAR
*
*******************************

CLROBJ EQU *
 PSHS D,X
 DI
 LDB ROOM
 PSHS B
 STA ROOM
 JSR PNTRM1
A@ LDA ,X+
 BEQ B@
 CMPA #MXMVOB
 BHI A@
 LEAX -1,X
 JSR GETOBJ
 BRA A@
B@ PULS B
 STB ROOM
 EI
 PULS D,X,PC

******************************
*
* GET VERB PROCESSOR
*
*******************************

VGET EQU *
 JSR EQUOBJ
 LDA NOUNNO VALID NOUN?
 LBEQ BADINP NO
 CMPA #128 IS IT "GET ALL"?
 BEQ I@ YES
 JSR LOCOBJ
 BEQ M@
 CMPA #MXMVOB IMMOVABLE OBJ?
 LBHI DMSG15 YES
 JSR HAVOBJ
 LBNE ALRHAV ALREADY HAS IT
 LDA OBJCNT CAN HE CARRY MORE?
 CMPA #MAXOBJ
 BHS E@ NO
 LDA NOUNNO SEE IF IN ROOM
 JSR GETOBJ
 BNE F@ FOUND OBJ
M@ JMP NOSEE
E@ JMP DMSG9
VGET01 EQU *
F@ JSR GIVOBJ
 JSR CKDRAW
H@ JMP REPLY
I@ JSR PNTRM1
J@ TST ,X+
 BMI J@ UNSEEN OBJ
 BEQ H@ END OF OBJ
 LDA OBJCNT
 CMPA #MAXOBJ
 BHS E@ CAN'T CARRY MORE
 LDA -1,X
 CMPA #MXMVOB IS IT PERM OBJ?
 BHI J@ YES
 JSR CHKGA CHK ADV RESTRICT
 BEQ J@
 JSR GETOBJ
 JSR GIVOBJ
 JSR CKDRAW
 BRA I@

*******************************
*
* SCORE VERB PROCESSOR
*
*******************************

VSCORE EQU *
 LDB POINTS
 CLRA
 TFR D,X
 LDY #MSG24B
 JSR ASCLNO
 BSR SUPRES
 LDX SCORE
 LEAX -1,X
 STX SCORE
 LDY #MSG24A
 JSR ASCLNO
 BSR SUPRES
 JMP DMSG24

*******************************
*
* ZERO SUPPRESS ASCII NUMBER
*
*******************************

SUPRES EQU *
 PSHS D,Y
 LDB #4
A@ LDA #'0
 CMPA ,Y+
 BNE B@
 LDA #$20
 STA -1,Y
 DECB
 BNE A@
B@ PULS D,X,PC

******************************
*== GETOBJ ==
* SEE IF OBJECT IS IN ROOM AND
* GET IT IF FOUND
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: A = 0 -> NOT FOUND
*         A > 0 FOUND & REMOVED
*
*******************************

VEC16 EQU *
 PSHS B,X
 JSR PNTRM1
A@ TST ,X
 BEQ C@
 CMPA ,X+
 BNE A@
B@ LDB ,X
 STB -1,X
 LEAX 1,X
 CMPX #RMOBT2
 BLO B@
 TSTA
 BRA D@
C@ CLRA
D@ PULS B,X,PC

*******************************
*== HAVOBJ ==
* CHK IF PLAYER HAS AN OBJECT
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: A = 0 -> HE DOESN'T
*           > 0 -> HE HAS IT
*
*******************************

VEC15 EQU *
 PSHS B,X
 LDX #OBJECT
 LDB #MAXOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 CLRA
B@ TSTA
 PULS B,X,PC

*******************************
*== REPOBJ ==
* REPLACE OBJECT PLAYER HAS
*
* INPUT:  A = OBJ TO FIND
*         B = REPLACEMENT
* OUTPUT: NONE
*
*******************************

VEC14 EQU *
 PSHS D,X
 PSHS B
 LDX #OBJECT
 LDB #MAXOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B
 BRA C@
B@ PULS B
 STB -1,X
 TSTB
 BNE C@
 DEC OBJCNT
C@ PULS D,X,PC

*******************************
*== GIVOBJ ==
* GIVE PLAYER AN OBJECT
*
* INPUT:  A = OBJECT TO GIVE
* OUTPUT: NONE
*
*******************************

VEC13 EQU *
 PSHS B,X
 LDX #OBJECT
 LDB #MAXOBJ
A@ TST ,X+
 BEQ B@
 DECB
 BNE A@
 BRA C@
B@ STA -1,X
 TSTA
 BEQ C@
 INC OBJCNT
C@ PULS B,X,PC

*******************************
*== LOCOBJ ==
* LOCATE OBJECT EITHER IN
* PLAYERS HAND OR CURRENT ROOM
*
*******************************

VEC21 EQU *
 PSHS D
 TFR A,B
 JSR HAVOBJ
 BNE A@
 TFR B,A
 JSR CKOBJ
A@ PULS D,PC

*******************************
*
* SPECIAL EXIT ROOM ROUTINES
*
*******************************

*******************************
*== BADINP ==
* I JUST DON'T UNDERSTAND RTN
*
*******************************

VEC06 EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #MSG4 DON'T UNDERSTAND
 JSR DISPLY
 LDX #KEYBUF
 JSR DISPLY
 LDA #'"
 JSR CHROUT
 BRA VEC07A

*******************************
*== REPLY ==
* ADVENTURE MAINLINE ROUTINE
* GET KEYBOARD INPUT, EXAMINE
* AND EXECUTE IT.
*
*******************************

VEC07 EQU *
 LDS #GSCRN
 LDA POINTS
 CMPA #MAXPNT
 LBEQ FINI
 TST NEWRM
 BEQ D@
 CLR FLIPSW
 CLR FLIPCT
 CLR FLIPCT+1
 CLR FLP2SW
 CLR FLP2CT
 CLR FLP2CT+1
 CLR RMMOVE
 LDX #ENTRTB
 CLR NEWRM
 BRA E@
D@ LDX #INRMTB
E@ LDA ,X+
 BEQ G@
 CMPA ROOM
 BEQ F@
 LEAX 2,X
 BRA E@
F@ JSR [,X]
G@ JSR ECHMOV
VEC07A LDX #MSG0 OK PROMPT
 JSR DISPLY
 JSR GETLIN GET KBD INPUT
 JSR SCNKEY EXAMINE INPUT
 INC RMMOVE
 LDD SCORE
 ADDD #1
 STD SCORE
 LDX #SPCRTN SPECIAL ROUTINE
A@ LDD ,X++
 BEQ C@
 CMPD VERBNO
 BNE B@
 JMP [,X]
B@ LEAX 2,X
 BRA A@
C@ LDB VERBNO CURRENT VERB
 LBEQ BADINP VERB NOT FOUND
 DECB
 LSLB
 LDX #RTNTAB VERB ROUTINES
 ABX
 JMP [,X]

*******************************
*== SCNKEY ==
* EXAMINE KEYBOARD INPUT AND
* EXTRACT THE VERB AND NOUN
*
* INPUT:  NONE
* OUTPUT: "VERB" CONTAINS VERB
*         "NOUN" CONTAINS NOUN
*
*******************************

VEC08 EQU *
 PSHS D,X,Y,U SAVE REGS
 LDX #VERB SPACE OUT VERB/NOUN
 TFR X,Y
 LDB #MAXWRD*2-1
 LDA #$20
 STA ,Y+
 JSR MOVE
 TFR X,U
 LDX #KEYBUF KEYBOARD BUFFER
 LDB #MAXWRD MAX VERB SIZE
A@ LDA ,X+ GET THE VERB
 BEQ E@ IF END OF TEXT
 CMPA #$20 IS IT SPACE?
 BEQ B@ YES:END OF VERB
 STA ,U+ PUT IN "VERB"
 DECB
 BNE A@ LOOP THRU VERB
F@ LDA ,X+ SCAN FOR A SPACE
 BEQ E@
 CMPA #$20
 BNE F@
B@ LDA ,X+ GET NEXT CHAR
 BEQ E@ IF END OF TEXT
 CMPA #$20 IS IT A SPACE
 BEQ B@ YES:LOOP TILL NON-BLANK
 DEX BACKUP 1 CHAR
 LDU #NOUN STORAGE FOR NOUN
 LDB #MAXWRD MAX LEN OF NOUN
D@ LDA ,X+ GET NEXT CHAR
 BEQ E@ IF END OF TEXT
 CMPA #$20 SPACE?
 BEQ E@ YES:ALL DONE
 STA ,U+ PUT IN "NOUN"
 DECB
 BNE D@
E@ CLR VERBNO CLEAR VERB/NOUN #
 CLR NOUNNO
 BSR CVTCAP
 LDX #VERBTB GET VERB NUMBER
 LDY #VERBNO
 LDU #VERB
 BSR SCNTBL
 LDX #NOUNTB GET NOUN NUMBER
 LDY #NOUNNO
 LDU #NOUN
 BSR SCNTBL
 PULS D,X,Y,U,PC

*******************************
*
* SCANS TABLE FOR VERB OR NOUN
* RETURNS ASSOCIATED VERB OR
* NOUN NUMBER.
*
* INPUT:  X = PNTR TO TABLE
*         Y = PNTR TO STORAGE
*             FOR VERB/NOUN #
*         U = PNTR TO KEYBOARD
*             INPUT TO SCAN FOR
* OUTPUT: CONTENTS OF "Y" ARE
*         ASSIGNED VERB/NOUN #
*
*******************************

SCNTBL EQU *
 PSHS D,X SAVE REGS
A@ PSHS U
 LDB #MAXWRD LEN OF COMPARE
B@ LDA ,X+ CHAR FROM TABLE
 BEQ C@ IF END OF TABLE
 CMPA ,U+ DO THEY MATCH?
 BNE D@ NO:NEXT TABLE ENTRY
 DECB COMPARE LEN
 BNE B@ LOOP TILL DONE
 LDA ,X GET VERB/NOUN #
 STA ,Y UPDATE USER AREA
C@ PULS U RESTORE "U"
 PULS D,X,PC
D@ INX BUMP TO NEXT ENTRY
 DECB
 BNE D@
 PULS U RESTORE VERB/NOUN
 BRA A@

*******************************
*
* CONVERTS INPUT VERB/NOUN TO
* ALL UPPER CASE LETTERS
*
* INPUT:  NONE
* OUTPUT: "VERB" & "NOUN" ARE
*         CONVERTED TO CAPS
*
*******************************

CVTCAP EQU *
 PSHS D,X SAVE REGS
 LDX #VERB
 LDB #MAXWRD*2
A@ LDA ,X+
 CMPA #'a LESS THAN L/C A?
 BLO B@ YES:SKIP
 CMPA #'z GREATER THEN L/C Z?
 BHI B@ YES:SKIP
 SUBA #32 MAKE UPPER CASE
 STA -1,X PUT IT BACK
B@ DECB
 BNE A@
 PULS D,X,PC

*******************************
*== PERIOD ==
* BACKUP & ADD PERIOD TO SCREEN
*
*******************************

VEC09 EQU *
 PSHS D,X,Y
A@ JSR CURPOS
 LDY #CHRCMA
 LDB #9
B@ LDA ,Y+
 COMA
 CMPA ,X
 BNE C@
 LEAX 32,X
 DECB
 BNE B@
 LDA #'.
 JSR CHROUT
 PULS D,X,Y,PC
C@ LDA #8
 JSR CHROUT
 BRA A@

*******************************
*== CHGOBJ ==
* REPLACE OBJECT IN CURRENT
* ROOM WITH ANOTHER OBJECT
*
* INPUT:  A = OBJ TO FIND
*         B = REPLACEMENT OBJ
* OUTPUT: NONE
*
*******************************

VEC10 EQU *
 PSHS D,X
 TSTB
 BEQ C@
 JSR PNTRM1
A@ TST ,X
 BEQ B@
 CMPA ,X+
 BNE A@
 STB -1,X
B@ PULS D,X,PC
C@ JSR GETOBJ
 BRA B@

*******************************
*== EQUOBJ ==
* CHECK FOR OBJECT NUMBERS
* THAT ARE EQUATED TO OTHER
* OBJECTS.
*
* INPUT:  NOUNNO = OBJ #
* OUTPUT: NOUNNO = NEW OBJ #
*
*******************************

EQUOBJ EQU *
 PSHS A,X
 LDX #EQUTAB
A@ LDA ,X+
 BEQ D@
 CMPA NOUNNO
 BNE C@
B@ LDA ,X+
 BEQ D@
 JSR LOCOBJ
 BEQ B@
 STA NOUNNO
 BRA D@
C@ TST ,X+
 BNE C@
 BRA A@
D@ PULS A,X,PC

*******************************
*== XCHGOB ==
* EXCHANGE AN OBJECT ANYWHERE
* IN THE GAME
*
* INPUT:  A = OBJ #
*         B = NEW OBJ #
* OUTPUT: NONE
*
*******************************

 IFEQ R.XCHG
XCHGOB EQU *
 PSHS D,X
 DI
 TFR D,X
 LDB ROOM
 PSHS B
 LDB #NORMS
 STB ROOM
 TFR X,D
 JSR REPOBJ
A@ JSR CHGOBJ
 DEC ROOM
 BNE A@
 PULS B
 STB ROOM
 EI
 PULS D,X,PC
 ENDC

*******************************
*== FNDOBJ ==
* FIND AN OBJECT SOMEWHERE IN
* THE GAME
*
* INPUT:  A = OBJ # TO FIND
* OUTPUT: A = 0 -> NOT FOUND
*           $FF -> PLAYER HAND
*            NN -> IN ROOM NN
*
*******************************

 IFEQ R.FIND
FNDOBJ EQU *
 DI
 PSHS B
 LDB ROOM
 PSHS B
 LDB #NORMS
 STB ROOM
 TFR A,B
 JSR HAVOBJ
 BEQ A@
 LDA #$FF
 BRA B@
A@ TFR B,A
 JSR CKOBJ
 BNE C@
 DEC ROOM
 BNE A@
 CLRA
B@ PULS B
 STB ROOM
 EI
 TSTA
 PULS B,PC
C@ LDA ROOM
 BRA B@
 ENDC

*******************************
*== CKOBJ ==
* TEST IF AN OBJECT IS IN THE
* CURRENT ROOM
*
* INPUT:  A = OBJ TO FIND
* OUTPUT: A = 0 -> NOT FOUND
*
*******************************

VEC11 EQU *
 PSHS X
 BSR PNTRM1
A@ TST ,X
 BEQ B@
 CMPA ,X+
 BNE A@
 TSTA
 BRA C@
B@ CLRA
C@ PULS X,PC

*******************************
*== MAKVIS ==
* MAKE AND OBJECT VISIBLE IN
* ROOM
*
* INPUT:  A = OBJECT TO FIND
* OUTPUT: NONE
*
*******************************

VEC12 EQU *
 PSHS X
 BSR PNTRM1
A@ TST ,X
 BEQ B@
 CMPA ,X+
 BNE A@
 ANDA #$7F
 STA -1,X
B@ PULS X,PC

*******************************
* = PNTRM1 =
*
* SET X REG TO POINT TO ENTRY
* IN TABLE.  ENTRY PNTRM1 IS FOR
* THE ROOM OBJECT TABLE AND
* ENTRY PNTRM2 IS FOR THE ROOM
* OVERLAY TABLE.
*
*******************************

PNTRM1 EQU *
 PSHS B
 LDX #RMOBT1
A@ LDB ROOM
B@ DECB
 BEQ D@
C@ TST ,X+
 BNE C@
 BRA B@
D@ PULS B,PC
PNTRM2 EQU *
 PSHS B
 LDX #SCRIND
 BRA A@

*******************************
*
* HELP VERB PROCESSOR
*
*******************************

VHELP EQU *
 LDX #GENHLP
 LDA RANDOM
 ANDA #3
 BEQ B@
A@ TST ,X+
 BNE A@
 DECA
 BNE A@
B@ JSR DISPLY
 JMP REPLY

*******************************
*
* DISPLAY MESSAGE ROUTINES
*
*******************************

DMSG9 LDA #9
 FCB $8C
DMSG12 LDA #12
 FCB $8C
DMSG13 LDA #13
 FCB $8C
DMSG14 LDA #14
 FCB $8C
DMSG15 LDA #15
 FCB $8C
DMSG16 LDA #16
 FCB $8C
DMSG17 LDA #17
 FCB $8C
DMSG18 LDA #18
 FCB $8C
DMSG19 LDA #19
 FCB $8C
DMSG20 LDA #20
 FCB $8C
DMSG21 LDA #21
 FCB $8C
DMSG22 LDA #22
 FCB $8C
DMSG23 LDA #23
 FCB $8C
DMSG24 LDA #24
 FCB $8C
DMSG26 LDA #26
 FCB $8C
DMSG27 LDA #27
 FCB $8C
DMSG28 LDA #28
 FCB $8C
DMSG29 LDA #29
 FCB $8C
DMSG30 LDA #30
 FCB $8C
DMSG31 LDA #31
 FCB $8C
*
* START ADVENTURE UNIQUE MSGS
*
DMSG37 LDA #37
 FCB $8C
DMSG40 LDA #40
 FCB $8C
DMSG43 LDA #43
 FCB $8C
DMSG57 LDA #57
DMSGXX LDX #MSG1
A@ DECA
 BEQ C@
B@ TST ,X+
 BNE B@
 BRA A@
C@ JSR DISPLY
 JMP REPLY

*      END GAME ROUTINE

DEAD1 EQU *
 PSHS X
 LDA #DEADRM
 STA ROOM
DEAD2 EQU *
 JSR CLS
 JSR DRAWSC
 PULS X
 JSR DISPLY
 BRA ENDGAM

FINI EQU *
 LDX #MSG27
 JSR DISPLY

ENDGAM EQU *
 LDB POINTS
 CLRA
 TFR D,X
 LDY #MSG25B
 JSR ASCLNO
 JSR SUPRES
 LDX SCORE
 LDY #MSG25A
 JSR ASCLNO
 JSR SUPRES
 LDX #MSG25
 JSR DISPLY
 JSR GETLIN
 LDA KEYBUF
 ANDA #%11011111
 CMPA #'Y
 LBEQ NEWGAM
 JMP BOMBIT

*
* END OF FILE: ADVENT01/ASM
*
