*  FILE: ADVENT03/ASM
*
* DATA VARIABLES AND TABLES
*

*******************************
*
* VERB TABLE.  EACH VERB IS
* LISTED FOLLOWED BY IT'S
* ASSIGNED VERB NUMBER.
*
*******************************

VERBTB EQU *
 FCC 'LOOK',1
 FCC 'L   ',1
 FCC 'EXAM',1
 FCC 'READ',1
 FCC 'INVE',2
 FCC 'I   ',2
 FCC 'G   ',3
 FCC 'GET ',3
 FCC 'TAKE',3
 FCC 'GRAB',3
 FCC 'PUT ',4
 FCC 'DROP',4
 FCC 'P   ',4
 FCC 'THRO',4
 FCC 'NORT',5
 FCC 'N   ',5
 FCC 'SOUT',6
 FCC 'S   ',6
 FCC 'EAST',7
 FCC 'E   ',7
 FCC 'WEST',8
 FCC 'W   ',8
 FCC 'UP  ',9
 FCC 'U   ',9
 FCC 'DOWN',10
 FCC 'D   ',10
 FCC 'GO  ',11
 FCC 'WALK',11
 FCC 'RUN ',11
 FCC 'SAVE',12
 FCC 'LOAD',13
 FCC 'HELP',14
 FCC 'SCOR',15
 FCC 'QUIT',16
 FCC 'OPEN',17
 FCC 'CLOS',18
 FCC 'EXIT',19
 FCC 'LEAV',19
 FCC 'INSE',20
 FCC 'UNLO',21
 FCC 'PRES',22
 FCC 'PUSH',22
 FCC 'TURN',23
 FCC 'PULL',24
 FCC 'MOVE',24
 FCC 'SAW ',25
 FCC 'PICK',26
 FCC 'POUR',27
 FCC 'CUT ',28
 FCC 'SQUE',29
 FCC 'GIVE',30
 FCC 'WEAR',31
 FCC 'DIG ',32
 FCC 'REMO',33
 FCC 'EAT ',34
 FCC 'MELT',35
 FCC 'HEAT',35
 FCC 'LIGH',36
 FCC 'UNLI',37
 FCC 'EXTI',37
 FCC 'MAKE',38
 FCC 'MOLD',38
 FCC 'DIAL',39
 FCC 'SET ',39
 FCB 0

*******************************
*
* NOUN TABLE.  LISTS ALL NOUNS
* AND THEIR ASSOCIATED NUMBER
*
*******************************

NOUNTB EQU *
 FCC 'NORT',1
 FCC 'SOUT',2
 FCC 'EAST',3
 FCC 'WEST',4
 FCC 'UP  ',5
 FCC 'DOWN',6
 FCC 'INVE',7
 FCC 'CALE',8
 FCC 'BLUE',9
 FCC 'CARB',10
 FCC 'HELM',10
 FCC 'COAL',11
 FCC 'SHOV',12
 FCC 'RED ',13
 FCC 'KEY ',14
 FCC 'PAGE',15
 FCC 'YELL',16
 FCC 'SAPP',17
 FCC 'GOLD',18
 FCC 'NUGG',18
 FCC 'JADE',19
 FCC 'BUDD',19
 FCC 'DOCU',20
 FCC 'BIRT',20
 FCC 'CERT',20
 FCC 'NOTE',21
 FCC 'SACK',23
 FCC 'BAG ',23
 FCC 'SAND',26
 FCC 'LIME',27
 FCC 'VIAL',28
 FCC 'HACK',29
 FCC 'SAW ',29
 FCC 'HAIR',30
 FCC 'PIN ',30
 FCC 'SCEP',31
 FCC 'DIAM',32
 FCC 'PEEL',35
 FCC 'PINK',36
 FCC 'SPAC',37
 FCC 'SUIT',37
 FCC 'NEWS',38
 FCC 'CLIP',38
 FCC 'WHIT',39
 FCC 'WAX ',41
 FCC 'STRI',43
 FCC 'CAND',44
 FCC 'BIRD',46
 FCC 'SPOO',47
 FCC 'SILV',48
 FCC 'CUP ',48
 FCC 'EMER',49
 FCC 'RUBY',50
 FCC 'NECK',50
 FCC 'PLAT',51
 FCC 'BRAC',51
 FCC 'BRAS',52
 FCC 'RING',52
 FCC 'CHAR',78
 FCC 'CHAP',78
 FCC 'PICT',79
 FCC 'SECR',82
 FCC 'PASS',82
 FCC 'LEVE',83
 FCC 'STAR',85
 FCC 'SHIP',85
 FCC 'MODE',85
 FCC 'ROCK',86
 FCC 'MUMM',87
 FCC 'SARC',89
 FCC 'MAE ',90
 FCC 'WATE',91
 FCC 'MUTA',92
 FCC 'HUMA',92
 FCC 'JUIC',93
 FCC 'PUDD',93
 FCC 'BATT',96
 FCC 'WORK',97
 FCC 'BENC',97
 FCC 'COUN',98
 FCC 'GADG',99
 FCC 'HOLE',100
 FCC 'TORC',102
 FCC 'CHES',106
 FCC 'WIND',108
 FCC 'BARS',108
 FCC 'SKEL',109
 FCC 'GATE',110
 FCC 'IRON',110
 FCC 'DIAL',113
 FCC 'SAFE',114
 FCC 'SIGN',115
 FCC 'PLAQ',116
 FCC 'GAUG',117
 FCC 'BUTT',118
 FCC 'SLOT',119
 FCC 'BOOK',120
 FCC 'TIME',121
 FCC 'MACH',121
 FCC 'CYLI',121
 FCC 'DEVI',122
 FCC 'OUT ',123
 FCC 'DESK',124
 FCC 'DRAW',124
 FCC 'CART',125
 FCC 'LOCK',126
 FCC 'DOOR',127
 FCC 'ALL ',128
 FCC 'EVER',128
 FCB 0

*******************************
*
* SPECIAL ACTION TABLE. LISTS
* VERB/NOUN COMBO'S THAT HAVE
* SPECIAL PROCESSING ROUTINES.
* FORMAT IS:
*
*  # BYTES       DEXCRIPTION
*  -------   ------------------
*     1      VERB NUMBER
*     1      NOUN NUMBER
*     2      SPECIAL RTN ADDR
*
*******************************

SPCRTN EQU *
 FDB $0109,LOOK04 LOOK BLUE
 FDB $010D,LOOK04 LOOK RED
 FDB $010F,LOOK11 LOOK PAGE
 FDB $0110,LOOK04 LOOK YELLOW
 FDB $0115,LOOK10 L NOTEBOOK
 FDB $0117,LOOK12 L SACK
 FDB $0157,LOOK09 L MUMMY
 FDB $015A,LOOK09 L MAE
 FDB $0161,LOOK09 L WORKBENCH
 FDB $0162,LOOK09 L COUNTER
 FDB $0166,LOOK14 L TORCH
 FDB $016A,LOOK13 L CHEST
 FDB $016D,LOOK15 L SKELETON
 FDB $0171,LOOK08 LOOK DIAL
 FDB $0172,LOOK05 LOOK SAFE
 FDB $0175,LOOK06 LOOK GAUGE
 FDB $0177,LOOK03 LOOK SLOT
 FDB $0178,LOOK01 LOOK BOOKCASE
 FDB $017C,LOOK02 LOOK DESK
 FDB $017D,DMSG37 LOOK CART
 FDB $017F,LOOK07 LOOK DOOR
 FDB $0307,VINVE TAKE INVENTORY
 FDB $0308,GET01 GET CALENDAR
 FDB $0309,GET02 GET BLUE
 FDB $030D,GET02 GET RED
 FDB $0310,GET02 GET YELLOW
 FDB $0324,GET02 GET PINK
 FDB $0327,GET02 GET WHITE
 FDB $0353,GET03 GET LEVER
 FDB $037B,GO03  GET OUT
 FDB $037D,DMSG37 GET CART
 FDB $0425,PUT01  PUT SUIT
 FDB $047D,DMSG37 PUT CART
 FDB $0B52,GO07  GO PASSAGE
 FDB $0B64,GO05  GO HOLE
 FDB $0B6C,GO06  GO WINDOW
 FDB $0B79,GO01  GO TIME MACH
 FDB $0B7A,GO02  GO DEVICE
 FDB $0B7B,GO03  GO OUT
 FDB $0B7F,GO04  GO DOOR
 FDB $1115,OPEN03 NOTEBOOK
 FDB $1159,OPEN04 OPEN SARC
 FDB $116A,LOOKOB OPEN CHEST
 FDB $116E,OPEN05 OPEN GATE
 FDB $117C,OPEN02 OPEN DESK
 FDB $117F,OPEN01 OPEN DOOR
 FDB $1215,CLOS03 NOTEBOOK
 FDB $127C,CLOS02 CLOSE DESK
 FDB $127F,CLOS01 CLOSE DOOR
 FDB $157F,UNLK01 UNLOCK DOOR
 FDB $170F,TURN03 TURN PAGE
 FDB $1771,TURN01 TURN DIAL
 FDB $1766,TURN02 TURN TORCH
 FDB $1753,TURN04 TURN LEVER
 FDB $1866,TURN02 PULL TORCH
 FDB $1853,TURN04 PULL LEVER
 FDB $191B,SAW02  SAW LIME
 FDB $196C,SAW01  SAW WINDOW
 FDB $1A7E,PICK01 PICK LOCK
 FDB $1B1C,POUR01 POUR VIAL
 FDB $1B5D,POUR01 POUR JUICE
 FDB $1C1B,SAW02  CUT LIME
 FDB $1D1B,SQU01  SQUEEZE LIME
 FDB $1E34,GIVE01 GIVE RING
 FDB $1F25,WEAR01 WEAR SUIT
 FDB $2125,REMO01 REMOVE SUIT
 FDB $2329,MELT01 MELT WAX
 FDB $232E,MELT01 MELT BIRD
 FDB $242C,LITE01 LITE CANDLE
 FDB $252C,UNLI01 UNLI CANDLE
 FDB $262C,MAKE01 MAKE CANDLE
 FDB $2771,TURN01 DIAL DIAL
 FDB 0

*******************************
*
* SPECIAL ACTION ON ENTRY TO A
* ROOM TABLE.  FORMAT IS:
*      ROOM#,RTNADDR
*
*******************************

ENTRTB EQU *
 FCB 41,>ENTR41
 FCB 0

*******************************
*
* SPECIAL ACTION ON EXIT FROM
* A ROOM TABLE.
*
*******************************

EXITTB EQU *
 FCB 48,>INRM48
 FCB 50,>INRM48
 FCB 51,>INRM48
 FCB 0

*******************************
*
* SPECIAL ACTION FOR COMMANDS
* GIVEN WHILE IN A ROOM TABLE
*
*******************************

INRMTB EQU *
 FCB 14,>INRM15
 FCB 15,>INRM15
 FCB 47,>INRM15
 FCB 48,>INRM48
 FCB 50,>INRM48
 FCB 51,>INRM48
 FCB 0

*******************************
*
* MESSAGE TABLE FOR GENERAL
* LOOK AT OBJECT ROUTINE
*
* FMT: FCB OBJ#
*          MSG# IF CARRYING
*          MSG# IF IN ROOM
*
*******************************

OBJMSG EQU *
 FCB 008,033,033 CALENDAR
 FCB 015,033,033 CALENDAR
 FCB 020,051,010 BIRTH CERT
 FCB 021,052,010 NOTEBOOK
 FCB 025,022,012 EMPTY SACK
 FCB 028,022,010 VIAL
 FCB 033,066,010 FULL VIAL
 FCB 038,071,010 NEWS CLIPPING
 FCB 040,014,012 WEARING SUIT
 FCB 041,079,010 HARD WAX
 FCB 042,080,010 SOFT WAX
 FCB 044,029,029 UNLIT CANDLE
 FCB 045,028,028 LIT CANDLE
 FCB 052,088,010 BRASS RING
 FCB 079,091,091 PICTURES
 FCB 083,086,086 EMPTY SARC
 FCB 084,086,086 EMPTY SARC
 FCB 085,087,087 TREKBOER
 FCB 088,085,085 OPEN SARC
 FCB 089,016,016 CLOSED SARC
 FCB 090,081,081 MAE WEST
 FCB 092,072,072 MUTANT
 FCB 094,062,062 BATTERY
 FCB 095,061,061 BATTERY
 FCB 096,060,060 BATTERY
 FCB 103,049,049 KING TUT SIGN
 FCB 104,047,047 HG WELLS SIGN
 FCB 105,018,018 OPEN CHEST
 FCB 106,017,017 LOCKED CHEST
 FCB 107,018,018 OPEN WINDOW
 FCB 108,057,057 BARRED WIND
 FCB 111,042,042 PRESSURE SIGN
 FCB 112,041,041 SAFE SIGN
 FCB 113,022,022 OPEN SAFE
 FCB 114,039,039 LOCKED SAFE
 FCB 115,055,055 SIGN
 FCB 116,032,032 PLAQUE
 FCB 119,038,038 SLOT
 FCB 120,048,048 BOOKCASE
 FCB 123,012,012 OPEN DESK
 FCB 124,035,035 CLOSED DESK
 FCB 125,018,018 OPEN DOOR
 FCB 126,016,016 CLOSED DOOR
 FCB 127,017,017 LOCKED DOOR
 FCB 0

*******************************
* OBJECT EQUATE TABLE DEFINES
* OBJECTS THAT MAY HAVE MULTIPLE
* OBJECT NUMBERS.
*
* FORMAT: FCB X,Y,Y,Y,Y
*  WHERE: X = PRIMARY OBJ #
*         Y = SECONDARY OBJ #
*             OR ZERO FOR NONE
*******************************

EQUTAB EQU *
 FCB 8,15,0         CALENDAR
 FCB 21,22,0        NOTEBOOK
 FCB 23,24,25,0     SACK LUNCH
 FCB 27,34,35,0     LIME
 FCB 28,33,0        VIAL
 FCB 37,40,0        SPACE SUIT
 FCB 41,42,0        WAX
 FCB 44,45,0        CANDLE
 FCB 89,88,83,84,0  SARC
 FCB 96,95,94,0     BATTERY
 FCB 100,80,81,0    HOLE
 FCB 102,101,0      TORCH
 FCB 106,105,0      CHEST
 FCB 108,107,0      WINDOW
 FCB 113,114,0      SAFE DIAL
 FCB 114,113,0      WALL SAFE
 FCB 115,112,111    SIGN
 FCB 104,103,0        "
 FCB 124,123,0      DEVICE
 FCB 127,126,125,0  DOOR
 FCB 0

*******************************
* DEFINE OBJECTS THAT SHOULD
* BE REFERRED TO AS "THEM"
*
* FORMAT IS: OBJ#,TYPE
*      WHERE TYPE IS:
*     0 = IT    1 = THEM
*     2 = HER   3 = HIM
*     4 = ONE   5 = ANY
*******************************

THEMTB EQU *
 FCB 034,1   LIME HALVES
 FCB 035,1   LIME PEELS
 FCB 078,3   CHARLIE CHAPLIN
 FCB 087,3   MUMMY
 FCB 090,2   MAE WEST
 FCB 092,3   MUTANT
 FCB 102,4   TORCHES
 FCB 0

*******************************
* LITERAL TABLE FOR IT,THEM,HIM
* HER MESSAGES.
*******************************

LITTAB EQU *
 FCC 'it.',0
 FCC 'them.',0
 FCC 'her.',0
 FCC 'him.',0
 FCC 'one.',0
 FCC 'any.',0

*
* TIME MACH MOVEMENT TABLE
*    FCB CART COLOR,TO ROOM

TIMTAB EQU *
 FCB 9,38  BLUE CART
 FCB 13,12 RED CART
 FCB 16,34 YELLOW CART
 FCB 36,16 PINK CART
 FCB 39,49 WHITE CART
 FCB 0

*******************************
*
* ROOM TABLE.  DEFINES THE
* LAYOUT OF THE ADVENTURE. EACH
* ENTRY HAS THE FOLLOWING
* FORMAT:
*
* # BYTES        DESCRIPTION
* -------   -------------------
*    1      ROOM # TO NORTH
*    1      ROOM # TO SOUTH
*    1      ROOM # TO EAST
*    1      ROOM # TO WEST
*    1      ROOM # UP
*    1      ROOM # DOWN
*
*******************************

ROOMTB EQU *
*ROOM 1
 FCB 0,2,5,0,0,0
*ROOM 2
 FCB 1,3,6,17,0,0
*ROOM 3
 FCB 2,4,7,18,0,0
*ROOM 4
 FCB 3,0,8,19,0,0
*ROOM 5
 FCB 0,0,0,1,0,0
*ROOM 6
 FCB 0,0,10,2,0,0
*ROOM 7
 FCB 0,0,11,3,0,0
*ROOM 8
 FCB 0,0,13,4,0,0
*ROOM 9
 FCB 0,0,0,0,0,0
*ROOM 10
 FCB 0,11,0,6,0,0
*ROOM 11
 FCB 10,13,0,7,0,0
*ROOM 12
 FCB 0,0,0,0,0,0
*ROOM 13
 FCB 11,0,0,8,0,0
*ROOM 14
 FCB 0,15,0,0,0,0
*ROOM 15
 FCB 14,47,0,0,0,0
*ROOM 16
 FCB 0,0,0,0,0,0
*ROOM 17
 FCB 0,0,2,0,0,0
*ROOM 18
 FCB 0,0,3,0,0,0
*ROOM 19
 FCB 0,0,4,0,0,0
*ROOM 20
 FCB 0,0,0,0,0,0
*ROOM 21
 FCB 0,0,0,0,0,0
*ROOM 22
 FCB 0,0,0,0,0,0
*ROOM 23
 FCB 0,24,27,0,0,0
*ROOM 24
 FCB 23,25,28,0,0,0
*ROOM 25
 FCB 24,26,29,0,0,0
*ROOM 26
 FCB 25,0,30,0,0,0
*ROOM 27
 FCB 0,0,0,23,0,0
*ROOM 28
 FCB 0,0,32,24,0,0
*ROOM 29
 FCB 0,0,33,25,0,0
*ROOM 30
 FCB 0,0,35,26,0,0
*ROOM 31
 FCB 0,0,0,0,0,0
*ROOM 32
 FCB 0,33,0,28,0,0
*ROOM 33
 FCB 32,35,0,29,0,0
*ROOM 34
 FCB 0,0,0,0,0,0
*ROOM 35
 FCB 33,0,0,30,0,0
*ROOM 36
 FCB 0,37,0,0,0,0
*ROOM 37
 FCB 36,39,0,0,0,0
*ROOM 38
 FCB 0,0,0,0,0,0
*ROOM 39
 FCB 37,0,40,41,0,0
*ROOM 40
 FCB 44,43,44,43,0,0
*ROOM 41
 FCB 0,0,0,0,0,0
*ROOM 42
 FCB 0,43,0,0,0,0
*ROOM 43
 FCB 43,0,0,44,0,0
*ROOM 44
 FCB 45,44,43,44,0,0
*ROOM 45
 FCB 44,45,39,45,0,0
*ROOM 46
 FCB 0,0,0,0,0,0
*ROOM 47
 FCB 15,0,0,0,0,0
*ROOM 48
 FCB 51,50,0,0,0,0
*ROOM 49
 FCB 0,0,0,0,0,0
*ROOM 50
 FCB 48,0,0,0,0,0
*ROOM 51
 FCB 0,48,0,0,0,0
*ROOM 52
 FCB 0,0,0,0,0,0
*ROOM 53
 FCB 0,0,0,0,0,0

* ROOM OBJECTS TABLE
* EACH VARIABLE LENGTH ENTRY
* DELIMITED BY $00

RMOBT1 EQU *
*ROOM 1
 FCB 127,0
*ROOM 2
 FCB 0
*ROOM 3
 FCB 0
*ROOM 4
 FCB 127,0
*ROOM 5
 FCB 124,8,9+INV,14+INV
 FCB 114+INV,16+INV,0
*ROOM 6
 FCB 0
*ROOM 7
 FCB 0
*ROOM 8
 FCB 98,99,21+INV,28+INV,0
*ROOM 9
 FCB 0
*ROOM 10
 FCB 122,118,112,10,11,0
*ROOM 11
 FCB 120,121,104,13+INV,0
*ROOM 12
 FCB 119,118,117,96,0
*ROOM 13
 FCB 79,0
*ROOM 14
 FCB 91,0
*ROOM 15
 FCB 91,121,38,0
*ROOM 16
 FCB 119,118,117,94,0
*ROOM 17
 FCB 78,90,51+INV,46,0
*ROOM 18
 FCB 116,37,86,85,0
*ROOM 19
 FCB 103,0
*ROOM 20
 FCB 125,118,0
*ROOM 21
 FCB 126,118,0
*ROOM 22
 FCB 125,115,97,23+INV,29+INV,0
*ROOM 23
 FCB 127,0
*ROOM 24
 FCB 0
*ROOM 25
 FCB 0
*ROOM 26
 FCB 0
*ROOM 27
 FCB 124,20+INV,0
*ROOM 28
 FCB 0
*ROOM 29
 FCB 0
*ROOM 30
 FCB 98,99,30+INV,0
*ROOM 31
 FCB 0
*ROOM 32
 FCB 122,12,118,112,0
*ROOM 33
 FCB 120,121,104,36+INV,0
*ROOM 34
 FCB 119,118,117,94,0
*ROOM 35
 FCB 79,0
*ROOM 36
 FCB 110,102,0
*ROOM 37
 FCB 121,102,0
*ROOM 38
 FCB 119,118,117,94,0
*ROOM 39
 FCB 102,0
*ROOM 40
 FCB 102,0
*ROOM 41
 FCB 127,109,108,47+INV
 FCB 43+INV,52+INV,0
*ROOM 42
 FCB 107,102,17,0
*ROOM 43
 FCB 102,0
*ROOM 44
 FCB 102,18,0
*ROOM 45
 FCB 102,0
*ROOM 46
 FCB 106,102,100,31+INV,19,0
*ROOM 47
 FCB 91,92,0
*ROOM 48
 FCB 121,0
*ROOM 49
 FCB 119,118,117,94,0
*ROOM 50
 FCB 0
*ROOM 51
 FCB 89,50+INV,0
*ROOM 52
 FCB 82,49,0
*ROOM 53
 FCB 80,48,0
*RESERVE AREAS
 FCB 10[0]
RMOBT2 FCB 0

*******************************
* TREASURE POINT TABLE
*
* FORMAT: FCB TREASURE,POINTS
*******************************

PNTTAB EQU *
 FCB 17,10 SAPPHIRE
 FCB 18,06 GOLD NUGGET
 FCB 19,13 JADE BUDDHA
 FCB 31,18 SCEPTER
 FCB 32,16 DIAMOND
 FCB 48,10 SILVER CUP
 FCB 49,10 EMERALD
 FCB 50,15 RUBY NECKLACE
 FCB 51,02 PLATINUM BRACELET
 FCB 0

*******************************
*
* GRAPHIC SCREEN INDICATOR
* TABLE (BY ROOM)
*
*******************************

SCRIND EQU *
*ROOM 1
 FCB 5,34,35,36,37,33,38,39,16
 FCB 15,0
*ROOM 2
 FCB 5,20,21,22,23,24,16,19
 FCB 14,15,18,0
*ROOM 3
 FCB 5,20,21,22,23,25,26,16,19
 FCB 14,15,17,18,0
*ROOM 4
 FCB 5,34,35,36,16,14,15,0
*ROOM 5
 FCB 4,2,3,4,5,6,7,8,9,10,11
 FCB 12,13,56,57,58,59,0
*ROOM 6
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 112
 FCB 113,114,115,116,117,0
*ROOM 7
 FCB 4,140,141,142,143,144,145
 FCB 146,147,148,149,150,151
 FCB 152,153,0
*ROOM 8
 FCB 1,241,201,202,242,243,244
 FCB 245,246,247,248,249,250
 FCB 251,252,253,254,OV2,1
 FCB OV2,2,OV2,3,OV2,4,OV2,5
 FCB OV2,6,OV2,7,OV2,8,OV2,9
 FCB OV2,10,OV2,11,OV2,12
 FCB OV2,13,OV2,14,OV2,15
 FCB OV2,16,OV2,23,0
*ROOM 9
 FCB 4,225,201,202,0
*ROOM 10
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 112
 FCB 118,119,120,121,122,123
 FCB 124,0
*ROOM 11
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 128,131,132,133
 FCB 134,135,136,137,138,139,0
*ROOM 12
 FCB 2,176,177,178,179,180,181
 FCB 182,183,184,185,0
*ROOM 13
 FCB 4,140,141,142,143,144,145
 FCB OV2,37,OV2,38,OV2,39
 FCB OV2,40,OV2,41,OV2,42
 FCB OV2,43,OV2,44,OV2,45,0
*ROOM 14
 FCB 8,156,157,158,159,160,161
 FCB 162,163,164,165,166,0
*ROOM 15
 FCB 8,156,157,158,159,160,161
 FCB 164,165,166
 FCB 128,133,134,135
 FCB 136,0
*ROOM 16
 FCB 2,176,177,178,179,180,181
 FCB 182,183,184,185,0
*ROOM 17
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 112
 FCB OV2,26,OV2,27,OV2,28
 FCB OV2,29,OV2,30,OV2,31
 FCB OV2,32,0
*ROOM 18
 FCB 4,140,141,142,143,144,145
 FCB 167,168,169,170,171,175
 FCB 199,200,0
*ROOM 19
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 112,155,0
*ROOM 20
 FCB 7,68,69,70,71,74,0
*ROOM 21
 FCB 7,68,69,70,71,74,0
*ROOM 22
 FCB 2,77,78,79,80,81,82,83,84
 FCB 85,86,87,0
*ROOM 23
 FCB 5,34,35,36,37,33,38,39,16
 FCB 15,0
*ROOM 24
 FCB 5,20,21,22,23,24,16,19
 FCB 15,18,0
*ROOM 25
 FCB 5,20,21,22,23,16,19,14
 FCB 17,0
*ROOM 26
 FCB 5,34,35,36,16,14,0
*ROOM 27
 FCB 4,2,3,4,5,6,7,8,9,10,11
 FCB 12,13,56,57,58,59,0
*ROOM 28
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 112
 FCB 113,114,115,116,117,0
*ROOM 29
 FCB 4,140,141,142,143,144,145
 FCB 146,147,148,149,150,151
 FCB 152,153,0
*ROOM 30
 FCB 1,241,201,202,242,243,244
 FCB 245,246,247,248,249,250
 FCB 251,252,253,254,OV2,1
 FCB OV2,2,OV2,3,OV2,4,OV2,5
 FCB OV2,6,OV2,7,OV2,8,OV2,9
 FCB OV2,10,OV2,11,OV2,12
 FCB OV2,13,OV2,14,OV2,15
 FCB OV2,16,OV2,23,0
*ROOM 31
 FCB 4,225,201,202,0
*ROOM 32
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 112
 FCB 118,119,120,121,122,123
 FCB 124,0
*ROOM 33
 FCB 3,92,93,94,95,96,97,98,99
 FCB 100,101,102,103,104,105
 FCB 106,107,108,109,110,111
 FCB 128,131,132,133,134,135
 FCB 136,137,138,139,0
*ROOM 34
 FCB 2,176,177,178,179,180,181
 FCB 182,183,184,185,0
*ROOM 35
 FCB 4,140,141,142,143,144,145
 FCB OV2,37,OV2,38,OV2,39
 FCB OV2,40,OV2,41,OV2,42
 FCB OV2,43,OV2,44,OV2,45,0
*ROOM 36
 FCB 6,43,44,54,55,186,187,0
*ROOM 37
 FCB 6,128,133,134,135,136,0
*ROOM 38
 FCB 2,176,177,178,179,180,181
 FCB 182,183,184,185,0
*ROOM 39
 FCB 6,43,44,54,55,0
*ROOM 40
 FCB 6,27,28,40,48,41,49,42
 FCB 43,44,54,55,0
*ROOM 41
 FCB 6,197,198,188,189,190,191
 FCB 192,193,0
*ROOM 42
 FCB 6,27,28,40,48,41,49,42
 FCB 43,44,54,55,195,196,0
*ROOM 43
 FCB 6,27,28,40,48,41,49,42
 FCB 43,44,54,55,0
*ROOM 44
 FCB 6,27,28,40,48,41,49,42
 FCB 43,44,54,55,0
*ROOM 45
 FCB 6,27,28,40,48,41,49,42
 FCB 43,44,54,55,0
*ROOM 46
 FCB 6,197,198,OV2,62,0
*ROOM 47
 FCB 8,156,157,158,159,160,161
 FCB 162,163,164,165,166,0
*ROOM 48
 FCB 4,225,226,203,204,227,228
 FCB 229,230,231,232,233,234
 FCB 235,236,237,0
*ROOM 49
 FCB 2,176,177,178,179,180,181
 FCB 182,183,184,185,0
*ROOM 50
 FCB 4,225,226,203,204,227,228
 FCB 229,230,231,232,233,234
 FCB 235,236,237,0
*ROOM 51
 FCB 4,225,201,202,203,204,205
 FCB 206,207,208,209,210,211
 FCB 212,213,214,215,216,217,0
*ROOM 52
 FCB 4,225,201,202,203,204,206
 FCB 207,209,210,211,212,213
 FCB 214,215,216,217,227,240,0
*ROOM 53
 FCB 9,201,202,0

*******************************
*
* ANTIMATION ROUTINES BY ROOM
*
* FORMAT: ROOM #,RTN VECTOR
*
*******************************

ANTTAB EQU *
 FCB 07,>MOVFSH
 FCB 08,>MOVLAB
 FCB 29,>MOVFSH
 FCB 30,>MOVLAB
 FCB 36,>MOVTOR
 FCB 37,>MOVTOR
 FCB 39,>MOVTOR
 FCB 40,>MOVTOR
 FCB 42,>MOVTOR
 FCB 43,>MOVTOR
 FCB 44,>MOVTOR
 FCB 45,>MOVTOR
 FCB 47,>MOVMUT
 FCB 0

*******************************
*
* IF OBJECT DROPPED IN ROOM
* PUT IT IN ANOTHER ROOM TABLE
*
* FORMAT: CURR ROOM,NEW ROOM
*
*******************************

PUTTAB EQU *
 FCB 0

GENHLP EQU *
 FCB 13,'T','r','y'+SPC
 FCC 'examinin','g'+SPC
 FCC 'things.',0

 FCB 13,'N','o'+SPC
 FCC 'HEL','P'+SPC
 FCC 'available.',0

 FCB 13,'U','s','e'+SPC
 FCC 'SAV','E'+SPC
 FCC 'whe','n'+SPC
 FCC 'enterin','g'+SPC
 FCC 'dangerou','s'+SPC
 FCC 'areas.',0

 FCB 13,C.IM
 FCC 'stumpe','d'+SPC
 FCC 'too!',0

*******************************
*
* DIRECTION DESCRIPTIONS TABLE
*
*******************************

DIRECT EQU *
 FCC 'North',','+SPC,0
 FCC 'South',','+SPC,0
 FCC 'East',','+SPC,0
 FCC 'West',','+SPC,0
 FCC 'Up',','+SPC,0
 FCC 'Down',','+SPC,0

*******************************
*
* COMPRESSED PHRASE TABLE
*
*******************************

TXTTAB EQU *
 FCC 'th','e'+SPC,0
 FCC 'smal','l'+SPC,0
 FCC 'ar','e'+SPC,0
 FCC 'se','e'+SPC,0
 FCC 'can',QUOTE,'t'+SPC,0
 FCC 'don',QUOTE,'t'+SPC,0
 FCC 'larg','e'+SPC,0
 FCB 'I',QUOTE,'m'+SPC,0
 FCB C.IN,'a'+SPC,0
 FCB 'o','n'+SPC,'a'+SPC,0
 FCB 'i','s'+SPC,'a'+SPC,0
 FCC 'It',QUOTE,'s'+SPC,0
 FCC 'Th','e'+SPC,0
 FCB 'i','s'+SPC,0
 FCC 'an','d'+SPC,0
 FCB 'a','n'+SPC,0
 FCB 'a','t'+SPC,0
 FCB 'o','f'+SPC,0
 FCB 'I','t'+SPC,'s','a','y','s',':',13,0
 FCC 'i','n'+SPC,0
 FCB 't','o'+SPC,0

*******************************
*
* VERB ROUTINE JUMP VECTORS
*
*******************************

RTNTAB EQU *
 FDB VLOOK,VINVE,VGET,VPUT
 FDB VNORTH,VSOUTH,VEAST,VWEST
 FDB VUP,VDOWN,VGO,VSAVE
 FDB VLOAD,VHELP,VSCORE,ENDGAM
 FDB BADINP,BADINP,GO03
 FDB VINSRT,BADINP,VPUSH,VTURN
 FDB BADINP,BADINP,BADINP
 FDB BADINP,BADINP,BADINP
 FDB VGIVE,BADINP,VDIG,BADINP
 FDB VEAT,BADINP,BADINP
 FDB BADINP,BADINP,VTURN

*******************************
*
* NON ARRAY VARIABLES
*
*******************************

COMMA FCB ','+SPC,0

*
* END OF FILE: ADVENT03/ASM
*
